/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using System.Collections;using System.Collections.Generic;using UnityEngine;namespace PluginIdea.ContexMenuSystem{public class GLLine2D{public Vector2 from;public Vector2 to;public Color color;}public class GLLine3D{public Vector3 from;public Vector3 to;public Color color;}public class GLQuad3D{public Vector3 ld;public Vector3 lu;public Vector3 rd;public Vector3 ru;public Color color;}public static class GLDrawHelper{public const int LINE = 1;public const int ARROW = 2;public const int ROTATE = 3;private static Material drawMaterial;private static Material DrawMaterial{get{if (drawMaterial == null){Shader shader = Shader.Find("Hidden/Internal-Colored");drawMaterial = new Material(shader);drawMaterial.hideFlags = HideFlags.HideAndDontSave;drawMaterial.SetInt("_SrcBlend", (int)UnityEngine.Rendering.BlendMode.SrcAlpha);drawMaterial.SetInt("_DstBlend", (int)UnityEngine.Rendering.BlendMode.OneMinusSrcAlpha);drawMaterial.SetInt("_Cull", (int)UnityEngine.Rendering.CullMode.Off);drawMaterial.SetInt("_ZWrite", 0);}return drawMaterial;}}public static void DrawQuad2D(Rect rect, Color rectColor){GL.PushMatrix();DrawMaterial.SetPass(0);GL.LoadPixelMatrix();GL.Begin(GL.QUADS);GL.Color(rectColor);GL.Vertex3(rect.min.x, rect.min.y, 0);GL.Vertex3(rect.max.x, rect.min.y, 0);GL.Vertex3(rect.max.x, rect.max.y, 0);GL.Vertex3(rect.min.x, rect.max.y, 0);GL.End();}public static void DrawLine3D(List<GLLine3D> lines, Transform centerAnchor){GL.PushMatrix();DrawMaterial.SetPass(0);if (centerAnchor != null){GL.MultMatrix(centerAnchor.localToWorldMatrix);}GL.Begin(GL.LINES);for (int i = 0;i < lines.Count;i++){GL.Color(lines[i].color);GL.Vertex(lines[i].from);GL.Vertex(lines[i].to);}GL.End();GL.PopMatrix();}public static void DrawQuad3D(List<GLQuad3D> qudes){GL.PushMatrix();DrawMaterial.SetPass(0);GL.Begin(GL.QUADS);for (int i = 0;i < qudes.Count;i++){GL.Color(qudes[i].color);GL.Vertex(qudes[i].ld);GL.Vertex(qudes[i].lu);GL.Vertex(qudes[i].ru);GL.Vertex(qudes[i].rd);}GL.End();GL.PopMatrix();}public static void DrawLine2D(List<GLLine2D> lines){GL.PushMatrix();DrawMaterial.SetPass(0);GL.LoadPixelMatrix();GL.Begin(GL.LINES);for (int i = 0;i < lines.Count;i++){GLLine2D line = lines[i];GL.Color(line.color);GL.Vertex3(line.from.x, line.from.y, 0);GL.Vertex3(line.to.x, line.to.y, 0);}GL.End();}}}