/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using System.Collections;using System.Collections.Generic;using UnityEngine;namespace PluginIdea.ContexMenuSystem{public static class LineRendererDrawHelper{public const int LINE = 1;public const int ARROW = 2;public const int ROTATE = 3;private static GameObject lineRendererObjectParent;private static Material drawMaterial;private static Material DrawMaterial{get{if (drawMaterial == null){Shader shader = Shader.Find("Hidden/Internal-Colored");drawMaterial = new Material(shader);drawMaterial.hideFlags = HideFlags.HideAndDontSave;drawMaterial.SetInt("_SrcBlend", (int)UnityEngine.Rendering.BlendMode.SrcAlpha);drawMaterial.SetInt("_DstBlend", (int)UnityEngine.Rendering.BlendMode.OneMinusSrcAlpha);drawMaterial.SetInt("_Cull", (int)UnityEngine.Rendering.CullMode.Off);drawMaterial.SetInt("_ZWrite", 0);}return drawMaterial;}}public static void RemoveLineRenderer(int id){if (dic_id2line.ContainsKey(id)){GameObject.Destroy(dic_id2line[id].gameObject);dic_id2line.Remove(id);}}private static Dictionary<int, LineRenderer> dic_id2line = new Dictionary<int, LineRenderer>();public static int DrawLine3DLineRenderer(List<GLLine3D> lines, Transform centerAnchor){if (lineRendererObjectParent == null) lineRendererObjectParent = new GameObject("LineRendererObject");lineRendererObjectParent.transform.position = new Vector3(100, 0, 0);GameObject line = new GameObject("line");LineRenderer lineRenderer = line.AddComponent<LineRenderer>();lineRenderer.material = DrawMaterial;lineRenderer.startWidth = lineRenderer.endWidth = 0.01f;lineRenderer.startColor = lineRenderer.endColor = lines[0].color;lineRenderer.positionCount = lines.Count + 1;List<Vector3> ps = new List<Vector3>();for (int i = 0;i < lines.Count;i++){ps.Add(lines[i].from);if (i == lines.Count - 1){ps.Add(lines[i].to);}}lineRenderer.SetPositions(ps.ToArray());int id = lineRenderer.GetInstanceID();if (!dic_id2line.ContainsKey(id)){dic_id2line.Add(id, lineRenderer);}return id;}}}