/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.UI;using UnityEngine.EventSystems;namespace PluginIdea.ContexMenuSystem{public class ContextMenuItem : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler, IPointerClickHandler{public delegate void StandardDelegate();public Text textLabel;public ContextMenu parentMenu, subMenu;public Text subMenuArrow;[HideInInspector]        public bool keepMenuOpen = false;StandardDelegate onClickMethod;public void Initialise(ContextMenu parentMenu, string description, StandardDelegate onClickMethod, ContextMenu subMenu, int fontSize){transform.name = description;this.parentMenu = parentMenu;textLabel.text = description;textLabel.fontSize = fontSize;textLabel.resizeTextForBestFit = !Utils.IsInVR();this.onClickMethod = onClickMethod;this.subMenu = subMenu;if (subMenu == null)                subMenuArrow.gameObject.SetActive(false);else                subMenu.parentMenu = parentMenu;}public void OnClick(){if (subMenu == null){if (onClickMethod != null)                    onClickMethod.Invoke();}}public void OnPointerEnter(PointerEventData eventData){keepMenuOpen = false;if (parentMenu != null && parentMenu.selector != null)                if (!parentMenu.selector.activeSelf)                    parentMenu.selector.SetActive(true);if (parentMenu.parentMenu != null)                parentMenu.parentMenu.SupressHiding();parentMenu.CloseOtherSubMenus(this);parentMenu.selector.transform.position = transform.position;if (subMenu != null && !subMenu.gameObject.activeSelf){subMenu.gameObject.SetActive(true);StartCoroutine(HoverFinished());}}public void OnPointerExit(PointerEventData eventData){if (subMenu != null){StopAllCoroutines();StartCoroutine(Hide());}}IEnumerator HoverFinished(){yield return new WaitForSeconds(ContextMenu.HoverTimer);subMenu.transform.position = transform.position;Vector3 startPosition = subMenu.transform.localPosition;startPosition += new Vector3(((RectTransform)parentMenu.transform).sizeDelta.x * 0.5f, 0, 0);float padding = ((RectTransform)transform).sizeDelta.y * 0.5f + subMenu.menuLayout.padding.bottom;if (ContextMenu.startingClickPosition.y > Screen.height / 2)                startPosition.y -= ((RectTransform)subMenu.transform).sizeDelta.y - padding;else                startPosition.y -= padding;if (ContextMenu.startingClickPosition.x > Screen.width / 2)                startPosition.x -= ((RectTransform)subMenu.transform).sizeDelta.x * 2;subMenu.transform.localPosition = startPosition;if (!Utils.IsInVR()){subMenu.transform.position += subMenu.GetOffset();}subMenu.gameObject.SetActive(true);}IEnumerator Hide(){yield return new WaitForSeconds(ContextMenu.HoverTimer * 2);if (!keepMenuOpen)                subMenu.Hide();}public void OnPointerClick(PointerEventData eventData){this.OnClick();}}}