/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using UnityEngine.EventSystems;namespace PluginIdea.ContexMenuSystem{public struct FaceToCamMode{public const int FaceToCamFree = 0;public const int FaceToCamXZ = 1;}public class FaceToCameraOpt : OptBase{public FaceToCameraOpt(CheckInfo checkInfo) : base(checkInfo){}public override void Proccess(){if (checkInfo.target != null){int mode = (int)checkInfo.extra;FreeControllerV3 fv3 = (checkInfo.target as Atom).mainController;Vector3 dir = (fv3.transform.position - Utils.CenterCameraTrans.position).normalized;if (mode == FaceToCamMode.FaceToCamFree){fv3.transform.LookAt(fv3.transform.position - dir);}else if (mode == FaceToCamMode.FaceToCamXZ){fv3.transform.LookAt(fv3.transform.position - new Vector3(dir.x, 0, dir.z));}}}}public struct AspectType{public const string t11 = "1:1";public const string t43 = "4:3";public const string t34 = "3:4";public const string t169 = "16:9";public const string t916 = "9:16";public const string t21 = "2:1";public const string t12 = "1:2";}public class ChangeAspectOpt : OptBase{public ChangeAspectOpt(CheckInfo checkInfo) : base(checkInfo){}public override void Proccess(){float aspect = 1.7778f;switch ((string)checkInfo.extra){case AspectType.t11: aspect = 1;break;case AspectType.t43: aspect = 1.333f;break;case AspectType.t21: aspect = 2;break;case AspectType.t169: aspect = 1.7778f;break;case AspectType.t34: aspect = 0.75f;break;case AspectType.t12: aspect = 0.5f;break;case AspectType.t916: aspect = 0.5625f;break;default:                    break;}int h = GlobalSetting.Resolution.y;int w = GlobalSetting.Resolution.x;if (aspect >= 1.7778f){h = (int)(w / aspect);}else{w = (int)(h * aspect);}float uiscale = Mathf.Lerp(0.5f, 1f, (float)w / GlobalSetting.Resolution.x);bool isWindowCam = checkInfo.type == "1" ? false : true;if (!isWindowCam){EventBus.Instance.BroadCastEvent<float>(EventID.OnUIScaleChangedEvent, uiscale);Screen.SetResolution(w, h, Screen.fullScreen);}else{var wincam = SuperController.singleton.GetAtomByUid("WindowCamera");if (wincam != null){var ctr = wincam.GetComponentInChildren<CameraControl>();ctr.cameraToControl.aspect = aspect;if (ctr.cameraToControl2 != null){ctr.cameraToControl2.aspect = aspect;}}}}}}